﻿
namespace RIAServicesDomain
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Data.Linq;
    using System.Linq;
    using System.Web.DomainServices;
    using System.Web.DomainServices.Providers;
    using System.Web.Ria;
    using System.Web.Ria.Services;
    using DotNetNuke.Entities.Users;
    using DotNetNuke.Entities.Portals;
    using System.Web;

    [EnableClientAccess()]
    public class RIADomainService : LinqToSqlDomainService<RIADALDataContext>
    {
        public IQueryable<RIAServicesTask> GetRIAServicesTasks()
        {
            // Get the current Portal
            PortalSettings objPortalSettings = 
                (PortalSettings)HttpContext.Current.Items["PortalSettings"];
            // Get the current UserID
            UserInfo objUserInfo = UserController.GetUserByName(objPortalSettings.PortalId,
                this.ServiceContext.User.Identity.Name);

            var result = from RIAServicesTasks in this.DataContext.RIAServicesTasks
                         where RIAServicesTasks.UserID == objUserInfo.UserID
                         select RIAServicesTasks;

            return result;
        }

        public void InsertRIAServicesTask(RIAServicesTask rIAServicesTask)
        {
            // Get the current Portal
            PortalSettings objPortalSettings = 
                (PortalSettings)HttpContext.Current.Items["PortalSettings"];
            // Get the current UserID
            UserInfo objUserInfo = UserController.GetUserByName(objPortalSettings.PortalId,
                this.ServiceContext.User.Identity.Name);

            rIAServicesTask.UserID = objUserInfo.UserID;
            this.DataContext.RIAServicesTasks.InsertOnSubmit(rIAServicesTask);
        }

        public void UpdateRIAServicesTask(RIAServicesTask currentRIAServicesTask)
        {
            this.DataContext.RIAServicesTasks.Attach(currentRIAServicesTask, 
                this.ChangeSet.GetOriginal(currentRIAServicesTask));
        }

        public void DeleteRIAServicesTask(RIAServicesTask rIAServicesTask)
        {
            this.DataContext.RIAServicesTasks.Attach(rIAServicesTask);
            this.DataContext.RIAServicesTasks.DeleteOnSubmit(rIAServicesTask);
        }
    }
}


